## undertaker 1.6.1

=== Makefile ===
OTHER_PROGS = scripts/kconfig/dumpconf tailor/undertaker-traceutil ziz/zizler
MANPAGES = doc/undertaker.1.gz doc/undertaker-linux-tree.1.gz doc/undertaker-kconfigdump.1.gz \
	doc/undertaker-kconfigpp.1.gz

PREFIX ?= /usr/local
BINDIR ?= $(PREFIX)/bin
SBINDIR ?= $(PREFIX)/sbin
LIBDIR ?= $(PREFIX)/lib
MANDIR ?= $(PREFIX)/share/man
DOCDIR ?= $(PREFIX)/share/doc
ETCDIR ?= $(PREFIX)/etc

VERSION=$(shell cat VERSION)

ifneq ($(LOCALPUMA),)
# to handle relative paths, call readlink
LOCALPUMA := $(shell readlink -e $(LOCALPUMA))
PUMALIB := $(LOCALPUMA)/lib/linux-release/libPuma.a
endif

ifneq (,$(DESTDIR))
SETUP_PY_EXTRA_ARG = --root=$(DESTDIR)
SETUP_PY_INSTALL_EXTRA_ARG = $(SETUP_PY_EXTRA_ARG)
endif

all: picosat/libpicosat.a checkpuma $(PUMALIB) FORCE
	$(MAKE) all_progs

all_progs: $(OTHER_PROGS) checkpuma undertaker_progs

undertaker_progs: checkpuma
	$(MAKE) -C undertaker/

version.h: generate-version.sh
	./$<

scripts/kconfig/conf: FORCE
	$(MAKE) -f Makefile.kbuild $(@F)

scripts/kconfig/dumpconf: scripts/kconfig/conf FORCE
	$(MAKE) -f Makefile.kbuild $(@F)

picosat/libpicosat.a:
	cd picosat && ./configure -static -O
	$(MAKE) -C picosat

###################################################################################################
# Puma targets

localpuma: aspectc/Puma/
	LOCALPUMA=aspectc/Puma/ $(MAKE)

aspectc/Puma/: ac-woven-1.2.tar.gz
	tar -xf ac-woven-1.2.tar.gz
	mv aspectc++/ aspectc/

ac-woven-1.2.tar.gz:
	wget http://aspectc.org/releases/1.2/ac-woven-1.2.tar.gz

# exitcode 0 = successful compiled, exitcode 1 = error
PUMAINSTALLED := $(shell echo "int main(){}" | gcc -o /dev/null -x c - -lPuma 2>/dev/null ; echo $$?)

checkpuma:
ifeq ($(LOCALPUMA),)
ifeq (0, $(words $(filter $(MAKECMDGOALS), localpuma)))
ifneq (0, $(PUMAINSTALLED))
	$(error "No local Puma library found! Please call 'make localpuma' or specify a path to a copy of the pre-woven Puma sources via 'LOCALPUMA=/path/to/aspectc++/Puma/ make'")
endif
endif
endif

ifneq ($(LOCALPUMA),)
$(PUMALIB):
	CPPFLAGS="-Wno-unused-local-typedefs -Wno-unused-parameter" $(MAKE) -s -C $(LOCALPUMA) compile

clean-Puma:
	$(MAKE) -C $(LOCALPUMA) libclean
endif

###################################################################################################

undertaker/undertaker: FORCE checkpuma
	$(MAKE) -C undertaker undertaker

undertaker/predator: FORCE checkpuma
	$(MAKE) -C undertaker predator

undertaker/rsf2cnf: FORCE
	$(MAKE) -C undertaker rsf2cnf

tailor/undertaker-traceutil: FORCE
	$(MAKE) -C tailor undertaker-traceutil

undertaker/satyr: FORCE
	$(MAKE) -C undertaker satyr

ziz/zizler: FORCE
	$(MAKE) -C ziz zizler

conf: scripts/kconfig/conf

clean:
	$(MAKE) -C undertaker clean
	$(MAKE) -C ziz clean
	$(MAKE) -C python clean
	$(MAKE) -C tailor clean
	$(MAKE) -C fm clean
	rm -rf doc/*.gz
	@python setup.py clean

distclean: clean
	$(MAKE) -C undertaker clean-parsers
	$(MAKE) -f Makefile.kbuild clean
	test ! -f picosat/makefile || $(MAKE) -C picosat clean
	test ! -f $(LOCALPUMA)/Makefile || $(MAKE) clean-Puma

models: picosat/libpicosat.a
	$(MAKE) -C undertaker/kconfig-dumps/

###################################################################################################
# check targets

CHECK_TARGETS = check-undertaker check-ziz check-python check-tailor check-fm

check: all
	$(MAKE) real_check

real_check: $(CHECK_TARGETS)

check-undertaker:
	$(MAKE) -C undertaker check

check-ziz:
	$(MAKE) -C ziz check

check-python:
	$(MAKE) -C python check

check-tailor:
	$(MAKE) -C tailor check

check-fm:
	$(MAKE) -s -C fm check

###################################################################################################
# install and release

install: all $(MANPAGES)
	@install -d -v $(DESTDIR)$(BINDIR)
	@install -d -v $(DESTDIR)$(SBINDIR)
	@install -d -v $(DESTDIR)$(DOCDIR)
	@install -d -v $(DESTDIR)$(LIBDIR)/undertaker
	@install -d -v $(DESTDIR)$(ETCDIR)/undertaker
	@install -d -v $(DESTDIR)$(LIBDIR)/undertaker/tailor/ubuntu-boot
	@install -d -v $(DESTDIR)$(PREFIX)/share/emacs/site-lisp/undertaker
	@install -d -v $(DESTDIR)$(DOCDIR)/undertaker/tailor
	@install -d -v $(DESTDIR)$(MANDIR)/man1

	@install -v python/undertaker-calc-coverage $(DESTDIR)$(BINDIR)
	@install -v python/undertaker-kconfigdump $(DESTDIR)$(BINDIR)
	@install -v python/undertaker-checkpatch $(DESTDIR)$(BINDIR)
	@install -v python/vampyr-spatch-wrapper $(DESTDIR)$(BINDIR)
	@install -v python/fakecc $(DESTDIR)$(BINDIR)

	@install -v scripts/kconfig/dumpconf $(DESTDIR)$(LIBDIR)/undertaker

	@install -v tailor/undertaker-tailor $(DESTDIR)$(BINDIR)
	@install -v tailor/undertaker-tracecontrol-prepare-debian $(DESTDIR)$(BINDIR)
	@install -v tailor/undertaker-tracecontrol-prepare-ubuntu $(DESTDIR)$(BINDIR)
	@install -v tailor/undertaker-tracecontrol $(DESTDIR)$(BINDIR)
	@install -v tailor/undertaker-traceutil $(DESTDIR)$(SBINDIR)
	@cp -v tailor/lists/* $(DESTDIR)$(ETCDIR)/undertaker/
	@cp -v tailor/HOWTO $(DESTDIR)$(DOCDIR)/undertaker/tailor/
	@cp -v tailor/README $(DESTDIR)$(DOCDIR)/undertaker/tailor/
	@cp -r -v tailor/boot/* $(DESTDIR)$(LIBDIR)/undertaker/tailor/ubuntu-boot

	@install -v undertaker/predator $(DESTDIR)$(BINDIR)
	@install -v undertaker/undertaker $(DESTDIR)$(BINDIR)
	@install -v undertaker/undertaker-linux-tree $(DESTDIR)$(BINDIR)
	@install -v undertaker/undertaker-coreboot-tree $(DESTDIR)$(BINDIR)
	@install -v undertaker/undertaker-scan-head $(DESTDIR)$(BINDIR)
	@install -v undertaker/undertaker-busybox-tree $(DESTDIR)$(BINDIR)
	@install -v undertaker/rsf2cnf $(DESTDIR)$(BINDIR)
	@install -v undertaker/satyr $(DESTDIR)$(BINDIR)

	@install -v picosat/picomus $(DESTDIR)$(BINDIR)

	@install -v ziz/zizler $(DESTDIR)$(BINDIR)

	@install -v scripts/Makefile.list $(DESTDIR)$(LIBDIR)
	@install -v scripts/Makefile.list_recursion $(DESTDIR)$(LIBDIR)
	@install -v scripts/Makefile.list_fiasco $(DESTDIR)$(LIBDIR)
	@install -v scripts/Makefile.version $(DESTDIR)$(LIBDIR)

	@install -v -m 0644 contrib/undertaker.el $(DESTDIR)$(PREFIX)/share/emacs/site-lisp/undertaker

	@install -v -m 0644 -t $(DESTDIR)$(MANDIR)/man1 $(MANPAGES)

	@python setup.py build $(SETUP_PY_BUILD_EXTRA_ARG)
	@python setup.py install --prefix=$(PREFIX) $(SETUP_PY_INSTALL_EXTRA_ARG)

dist: clean
	tar -czvf ../undertaker-$(VERSION).tar.gz . \
		--show-transformed-names \
		--transform 's,^./,undertaker-$(VERSION)/,'\
		--exclude=*~ \
		--exclude=*.rsf \
		--exclude=*.model \
		--exclude-vcs \
		--exclude="*nfs*" \
		--exclude="*git*" \
		--exclude=*.tar.gz \
		--exclude="*.html"

###################################################################################################
# other targets

undertaker-lcov: FORCE checkpuma
	$(MAKE) -C undertaker run-lcov

docs:
	$(MAKE) -C undertaker docs

%.1.gz: %.1
	gzip < $< > $@

ifdef REGENERATE_PARSERS

regenerate_parsers:
	$(MAKE) -C undertaker regenerate_parsers

endif

###################################################################################################

FORCE:
.PHONY: FORCE all all_progs check undertaker-lcov $(CHECK_TARGETS) docs regenerate_parsers \
	undertaker_progs localpuma clean-puma checkpuma

=== fm/Makefile ===
SATYR=$(CURDIR)/../undertaker/satyr
CONF=$(CURDIR)/../scripts/kconfig/conf
MODELS=$(wildcard *.fm)
CNFs=$(MODELS:.fm=.cnf)
ALLYESCONFIGS=$(MODELS:.fm=.allyesconfig)
ALLMODCONFIGS=$(MODELS:.fm=.allmodconfig)
ALLNOCONFIGS=$(MODELS:.fm=.allnoconfig)
ALLDEFCONFIGS=$(MODELS:.fm=.alldefconfig)
ALLCONFIGS=$(ALLYESCONFIGS) $(ALLNOCONFIGS) $(ALLMODCONFIGS) $(ALLDEFCONFIGS)

all: check

$(SATYR):
	$(MAKE) -s -C $(@D) $(@F)

$(CONF):
	$(MAKE) -s -C .. $(@F)

%.cnf: %.fm
	$(SATYR) $< -c $@

%.allyesconfig: %.fm $(CONF) $(SATYR)
	env KCONFIG_CONFIG=$@ $(CONF) $< --allyesconfig > /dev/null || (echo "Calculation of $@ failed" && exit 1)
	$(SATYR) $< -a $@ 2> /dev/null || (echo "call of satyr on $@ failed" && exit 1)

%.allnoconfig: %.fm $(CONF) $(SATYR)
	env KCONFIG_CONFIG=$@ $(CONF) $< --allnoconfig > /dev/null || (echo "Calculation of $@ failed" && exit 1)
	$(SATYR) $< -a $@ 2> /dev/null || (echo "call of satyr on $@ failed" && exit 1)

%.allmodconfig: %.fm $(CONF) $(SATYR)
	env KCONFIG_CONFIG=$@ $(CONF) $< --allmodconfig > /dev/null || (echo "Calculation of $@ failed" && exit 1)
	$(SATYR) $< -a $@ 2> /dev/null || (echo "call of satyr on $@ failed" && exit 1)

%.alldefconfig: %.fm $(CONF) $(SATYR)
	env KCONFIG_CONFIG=$@ $(CONF) $< --alldefconfig > /dev/null || (echo "Calculation of $@ failed" && exit 1)
	$(SATYR) $< -a $@ 2> /dev/null || (echo "call of satyr on $@ failed" && exit 1)

check: $(ALLCONFIGS)

clean:
	rm -rf $(CNFs) $(ALLCONFIGS) *.*.old


.PHONY: check clean all

=== python/Makefile ===
PYTHONPROGRAMS = busyfix golem rsf2model undertaker-calc-coverage undertaker-kconfigpp \
	vampyr undertaker-checkpatch
PYTHONFILES    = $(PYTHONPROGRAMS) $(wildcard vamos/*/*.py) $(wildcard vamos/*.py)
SEARCHPATH     = "$(CURDIR)/../undertaker:$(CURDIR)/../ziz:$(CURDIR):$(PATH)"

all:

pylint:
	-pylint --rcfile pylint.rc $(PYTHONFILES)

check:
	$(MAKE) -s clean-check
	@for test in vamos/*/*_test.py vamos/*_test.py; do \
	   echo "Running python unittest $$test"; \
	   if ! env PATH="$(SEARCHPATH)" PYTHONPATH=$(CURDIR) python "$$test"; then \
	       echo "FAIL: $$test"; exit 1; \
	   fi; \
	done
	cd validation && env PATH="$(SEARCHPATH)" ./test-suite
	$(MAKE) -s pylint

clean: clean-check

clean-check:
	find validation/ \( -name "*.output.expected" \
                     -o -name "*.output.got" \
                     -o -name "*.output.diff" \
                     -o -name "*.error.expected" \
                     -o -name "*.error.diff" \
                     -o -name "*.error.got" \
                     -o -name "*.c.config*" \
                     -o -name "*.c.cppflags*" \
                     -o -name "*.c.source*" \
                     -o -name "*.dead" \
                     -o -name "*.undead" \
                     -o -name "*.plist" \
                     -o -name "*config*.report.*" \
                     \) -delete

FORCE:
.PHONY: all clean clean-check pylint FORCE

=== scripts/Makefile ===
subdir-	+= basic kconfig

=== tailor/Makefile ===
CC = gcc
CXX = g++
CSTD = c99
CFLAGS = -O3 -Wall -pedantic -Wno-unused-result -ffast-math -ftracer -funroll-loops -fforce-addr
CXXSTD = c++0x
CXXFLAGS = -lboost_regex
TARGET=undertaker-traceutil
TESTDIR = sample
SRCDIR = src
VARIANT = native

.PHONY: all native stdio boost clean test testclean check install

all: $(VARIANT)

native: $(TARGET)

$(TARGET): $(SRCDIR)/traceutil-native.c
	$(CC) -std=$(CSTD) $(CFLAGS) $^ -o $(TARGET)

stdio: $(SRCDIR)/traceutil-stdio.c
	$(CC) -std=$(CSTD) $(CFLAGS) $^ -o $(TARGET)

boost: $(SRCDIR)/traceutil-boost.cc
	$(CXX) -std=$(CXXSTD) $(CFLAGS) $^ $(CXXFLAGS) -o $(TARGET)

clean: testclean
	rm -f $(TARGET)
	rm -f ftrace-initramfs.img
	rm -f initrd.img-*
	rm -f sample/test_ignore sample/test_out

check: $(TARGET) testclean
	@echo "Running trace..."
	./$(TARGET) $(TESTDIR)/test_trace $(TESTDIR)/test_out $(TESTDIR)/test_ignore $(TESTDIR)/test_modules
	@echo "Checking results..."
	@test -f $(TESTDIR)/test_out.`uname -m` || echo File $(TESTDIR)/test_out.`uname -m` not available... Ignoring.
	@test ! -f $(TESTDIR)/test_out.`uname -m` || diff $(TESTDIR)/test_out $(TESTDIR)/test_out.`uname -m`
	@diff $(TESTDIR)/test_ignore $(TESTDIR)/test_ignore.all
	@echo "(done)"

testclean:
	rm -f $(TESTDIR)/test_out $(TESTDIR)/test_ignore

test: check
	@echo -n "Checking if current booted kernel supports ftrace... "
	@cat /boot/config-`uname -r` | grep -q "CONFIG_FTRACE=y" && echo "Yes" \
	|| echo "No - you are not able to use this kernel without modification."

=== undertaker/Makefile ===
# Add .d to Make's recognized suffixes.
SUFFIXES += .d

#We don't need to clean up when we're making these targets
NODEPS:=clean clean-check clean-parsers clean-regenerate

CFLAGS = -Wall -Wextra -O2
CPPFLAGS = -I../scripts/kconfig -I../picosat
CXXFLAGS = $(CFLAGS) -std=gnu++11

# use g++ for linking, will automaticly use "-lstdc++ -lm" libraries
CC = g++

LDFLAGS =
BOOST_LIBS = -lboost_system -lboost_regex -lboost_filesystem -lboost_thread
LDLIBS = $(BOOST_LIBS) -lpthread

# LDCOV = -coverage
ifdef LDCOV
	LDLIBS += $(LDCOV)
endif

# DEBUG = -g3 -DDEBUG
# to compile with debug, compile like this:
# make DEBUG="-g3 -DDEBUG"
ifdef DEBUG
	CFLAGS += $(DEBUG)
endif

###################################################################################################
# static linking
# for this option to work, there have to be static versions of the boost libraries on your system!
# On Ubuntu, that's the default case when you install the boost libraries.
# ("locate libboost_filesystem.a" might help to ensure they are there)
ifdef STATIC
	LDFLAGS += -static
endif

###################################################################################################
# local Puma

ifneq ($(LOCALPUMA),)
CXXFLAGS += -Wno-unused-local-typedefs -Wno-unused-parameter
CPPFLAGS += -I$(LOCALPUMA)/include -I$(LOCALPUMA)/extern
PUMALIB = $(LOCALPUMA)/lib/linux-release/libPuma.a
else
LDLIBS += -lPuma
endif

###################################################################################################

PARSEROBJ = KconfigWhitelist.o Logging.o Tools.o \
		BoolExpLexer.o BoolExpParser.o BoolExpSymbolSet.o BoolExpSimplifier.o \
		BoolExpGC.o bool.o CNFBuilder.o PicosatCNF.o \
		ConditionalBlock.o PumaConditionalBlock.o RsfReader.o ModelContainer.o \
		ConfigurationModel.o RsfConfigurationModel.o CnfConfigurationModel.o \
		BlockDefectAnalyzer.o CoverageAnalyzer.o SatChecker.o

SATYROBJ = KconfigWhitelist.o Logging.o Tools.o \
		BoolExpLexer.o BoolExpParser.o BoolExpSymbolSet.o BoolExpSimplifier.o \
		BoolExpGC.o bool.o CNFBuilder.o PicosatCNF.o \
		ExpressionTranslator.o SymbolTranslator.o SymbolTools.o SymbolParser.o \
		KconfigAssumptionMap.o

PROGS = undertaker predator rsf2cnf satyr
TESTPROGS = test-SatChecker test-ConditionalBlock test-ConfigurationModel \
            test-Bool test-CNFBuilder test-BoolExpSymbolSet test-PicosatCNF

DEPFILES:=$(patsubst %.o,%.d,$(PARSEROBJ) $(SATYROBJ)) undertaker.d satyr.d

PARSERDIR = BoolExpLP

all: $(PROGS)

undertaker: libparser.a ../picosat/libpicosat.a $(PUMALIB)
rsf2cnf: libparser.a ../picosat/libpicosat.a
predator: predator.o PredatorVisitor.o $(PUMALIB)
satyr: libsatyr.a zconf.tab.o ../picosat/libpicosat.a

ifneq ($(LOCALPUMA),)
$(PUMALIB):
	$(MAKE) -C $(LOCALPUMA) compile
endif

../picosat/libpicosat.a:
	$(MAKE) -C .. picosat/libpicosat.a

../version.h:
	$(MAKE) -C .. version.h

undertaker.d rsf2cnf.d satyr.d: ../version.h

BoolExpLexer.d: BoolExpLexer.cpp BoolExpParser.hh location.hh stack.hh
BoolExpParser.d: BoolExpParser.cpp

location.hh: position.hh

%.hh: $(PARSERDIR)/%.hh
	cat $< > $@

%.cpp: $(PARSERDIR)/%.cpp_shipped
	cat $< > $@

bool.o: bool.cpp bool.h BoolExpParser.o

libparser.a: $(DEPFILES) $(PARSEROBJ)
	ar r $@ $(PARSEROBJ)

libsatyr.a: $(DEPFILES) $(SATYROBJ)
	ar r $@ $(SATYROBJ)

zconf.tab.o: ../scripts/kconfig/zconf.tab.o
	ln -sf $< $@

../scripts/kconfig/zconf.tab.o:
	$(MAKE) -C .. scripts/kconfig/conf

#Don't create dependencies when we're cleaning, for instance
ifeq (0, $(words $(filter $(MAKECMDGOALS), $(NODEPS))))
    #Chances are, these files don't exist.  GMake will create them and
    #clean up automatically afterwards
    -include $(DEPFILES)
endif

#This is the rule for creating the dependency files
%.d: %.cpp
	 @$(CXX) $(CPPFLAGS) $(CXXFLAGS) -MM -MG $< > $@

test-%: test-%.cpp libparser.a ../picosat/libpicosat.a $(PUMALIB)
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -g -O0 -o $@ $^ -lcheck -lrt $(LDFLAGS) $(LDLIBS)

clean: clean-check
	rm -rf *.o *.a *.gcda *.gcno *.d
	rm -rf coverage-wl.cnf
	rm -rf $(PROGS) $(TESTPROGS)

clean-parsers:
	rm -rf location.hh stack.hh position.hh BoolExpParser.hh
	rm -rf BoolExpParser.cpp BoolExpLexer.cpp

###################################################################################################
# check targets

CHECK_TARGETS = check-undertaker check-libs check-rsf2cnf check-coverage check-satyr

clean-check:
	find coverage-tests validation/ \
	                 \( -name "*.c.output.expected" \
	                 -o -name "*.c.output.got" \
	                 -o -name "*.c.output.diff" \
	                 -o -name "*.c.error.expected" \
	                 -o -name "*.c.error.got" \
	                 -o -name "*.c.error.diff" \
	                 -o -name "*.c.config*" \
	                 -o -name "*.c.cppflags*" \
	                 -o -name "*.c.source*" \
	                 -o -name "*.dead" \
	                 -o -name "*.dead.mus" \
	                 -o -name "*.undead" \
	                 \) -delete
	rm -vf coverage-tests/coverage-cat.c.got
	@$(MAKE) -C validation-rsf2cnf clean

check-libs: $(TESTPROGS)
	@for t in $^; do echo "Executing test $$t"; ./$$t || exit 1; done

check-rsf2cnf: rsf2cnf
	./rsf2cnf \
	    -m validation/coverage-wl.model \
	    -r validation/coverage-wl.rsf \
	    -W validation/coverage-wl.whitelist \
	    -B validation/coverage-wl.blacklist > coverage-wl.cnf
	@if ! diff -q coverage-wl.cnf validation/coverage-wl.cnf-ref; then \
	    diff -u validation/coverage-wl.cnf-ref coverage-wl.cnf; false; fi
	@$(MAKE) -C validation-rsf2cnf check

# coverage analysis will create validation/sched.c.config*
check-coverage: undertaker predator
	./undertaker -j coverage -C simple_decision -m kconfig-dumps/models validation/sched.c
#	we expect between 5 and 30 solutions
	test `find validation -name 'sched.c.config*' | wc -l` -gt 5
	test `find validation -name 'sched.c.config*' | wc -l` -lt 30
	md5sum validation/sched.c.config* | awk '// {print $$1}' | sort | uniq -c \
		| awk '// { if ($$1 != 1) { print "duplicate solutions found" ; exit 1 } }' \
		|| md5sum validation/sched.c.config* | sort
	if grep -q '^CONFIG_IA64=y' validation/sched.c.config*; then echo "IA64 must not be enabled!"; false ; fi
	if grep -q '^CONFIG_CHOICE' validation/sched.c.config*; then echo "must not contain CONFIG_CHOICE*"; false ; fi
	cd coverage-tests && env PATH=$(CURDIR):$(PATH) ./run-tests

check-satyr: satyr
	@cd validation-satyr && ./checkall.sh

check-undertaker: undertaker
	cd def-tests && env PATH=$(CURDIR):$(PATH) ./run-tests
	cd validation && env PATH=$(CURDIR):$(CURDIR)/../picosat:$(PATH) ./test-suite -t $$(getconf _NPROCESSORS_ONLN)

check: $(PROGS)
	@$(MAKE) -s clean-check
	@$(MAKE) -C kconfig-dumps all
	@$(MAKE) real-check

real-check: $(CHECK_TARGETS)

###################################################################################################
# gcov is a tool to measure code coverage while running the programs. Here we build our tools with
# gcov and run make check, thus we measure the code coverage of our tests.

run-lcov:
	$(MAKE) -B DEBUG="-g -O0 -fprofile-arcs -ftest-coverage" LDCOV="-coverage -lgcov" all $(TESTPROGS)
	rm -rf coverage-html ; mkdir coverage-html
	lcov --directory $(CURDIR) --zerocounters
	-$(MAKE) check
	lcov --directory $(CURDIR) --capture --output-file coverage-html/undertaker.info.in
	lcov -e coverage-html/undertaker.info.in "$(CURDIR)*" --output-file coverage-html/undertaker.info
	genhtml -o coverage-html coverage-html/undertaker.info

###################################################################################################
# other targets
ifdef REGENERATE_PARSERS

.PRECIOUS: $(PARSERDIR)/BoolExpParser.hh $(PARSERDIR)/BoolExpParser.cpp_shipped

regenerate_parsers: clean-parsers clean-regenerate
	$(MAKE) $(PARSERDIR)/BoolExpLexer.cpp_shipped

clean-regenerate:
	rm -rf $(PARSERDIR)/*_shipped $(PARSERDIR)/*.hh

$(PARSERDIR)/%.cpp_shipped: $(PARSERDIR)/%.l $(PARSERDIR)/BoolExpParser.cpp_shipped
	flex -o $@ $<

$(PARSERDIR)/%.cpp_shipped: $(PARSERDIR)/%.y
	bison -o $@ --defines=$(PARSERDIR)/BoolExpParser.hh $<

endif

docs:
	doxygen

###################################################################################################

FORCE:
.PHONY: all clean clean-% FORCE check check-% real-check run-lcov regenerate_parsers docs

=== ziz/Makefile ===
CXX=g++
LDXX=g++
DEBUG = -g3
CFLAGS = -Wall -Wextra -O2 $(DEBUG)
CXXFLAGS = $(CFLAGS) -std=gnu++11
LDFLAGS =
LDLIBS = -lboost_regex -lboost_wave -lboost_system $(LDCOV)

HEADERS = $(wildcard *.h)

###################################################################################################
# static linking
# for this option to work, there have to be static versions of the boost libraries on your system!
# On Ubuntu, that's the default case when you install the boost libraries.
# ("locate libboost_filesystem.a" might help to ensure they are there)
ifdef STATIC
	LDFLAGS += -static -lpthread
endif
###################################################################################################

all: zizler

Zizler.o: Zizler.cpp $(HEADERS)

zizler: Zizler.o Ziz.o
	$(LDXX) -o $@ $^ $(LDFLAGS) $(LDLIBS)

Ziz.o: $(HEADERS)

clean: clean-check
	rm -rf *.o *.a zizler

clean-check:
	rm -rf test/out

check test: all
	@mkdir -p test/out
	@cd test && ./test-suite.sh

test-clean:
	rm -rf test/out/*

.PHONY: check test

=== undertaker/kconfig-dumps/Makefile ===
DUMPCONF=../../scripts/kconfig/dumpconf
KCONFIGDUMP=../../python/undertaker-kconfigdump
SATYR=../satyr
FM_DIR=../../fm/linux
FM_FILES=$(subst $(FM_DIR)/,,$(wildcard $(FM_DIR)/*.fm))
RSF_FILES=$(FM_FILES:.fm=.rsf)
MODELS=$(patsubst %.rsf,models/%.model,$(RSF_FILES))
CNF_MODELS=$(patsubst %.rsf,cnfmodels/%.cnf,$(RSF_FILES))
PATH:=$(CURDIR)/..:$(CURDIR)/../../scripts/kconfig:$(CURDIR):../../python:$(PATH)
export PATH

all: models cnfmodels

models: $(DUMPCONF) $(MODELS)

cnfmodels: $(SATYR) $(CNF_MODELS)

../satyr:
	make -C .. satyr

../../scripts/kconfig/dumpconf:
	make -C ../.. scripts/kconfig/dumpconf

models/%.rsf: $(FM_DIR)/%.fm
	@mkdir -p models
	ARCH=$* $(DUMPCONF) $(FM_DIR)/$*.fm | sort -u | grep -v '^#' > $@

models/%.model: models/%.rsf
	$(KCONFIGDUMP) -m $* intermediate

cnfmodels/%.cnf: $(FM_DIR)/%.fm
	@mkdir -p cnfmodels
	ARCH=$* $(SATYR) $< -c $@

clean:
	rm -rf $(MODELS) $(CNF_MODELS)

FORCE:

.PHONY: FORCE all models cnfmodels
.SECONDARY:

=== undertaker/validation-rsf2cnf/Makefile ===
.PHONY: all clean check

RSF2CNF=../rsf2cnf

all: complete.cnf

clean:
	rm -f complete.cnf

$(RSF2CNF):
	$(MAKE) -C .. rsf2cnf

complete.cnf: mainmodel.cnf files.model $(RSF2CNF)
	$(RSF2CNF) -m files.model -c mainmodel.cnf >complete.cnf

check: complete.cnf
# note: the following tests are fragile, because the cnf variable encodings
# might change in future versions of the program.
	picosat complete.cnf; test $$? -eq 10
#unsatisfiable: FOO=n, FILE_interference.c=y
	picosat complete.cnf -a 4 -a -2; test $$? -eq 20
#satisfiable: FOO=y, FILE_interference.c=y
	picosat complete.cnf -a 4 -a 2; test $$? -eq 10

.PHONY: complete.cnf

=== tailor/flipper/kernel/drivers/misc/flipper/Makefile ===
obj-y	+= flipper.o

=== debian/changelog ===
undertaker (1.6.1-4.1build3) bionic; urgency=medium

  * No-change rebuild to pick up the shared flex library.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 20 Feb 2018 07:10:59 +0000

undertaker (1.6.1-4.1build2) bionic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 26 Oct 2017 17:25:07 +0000

undertaker (1.6.1-4.1build1) artful; urgency=medium

  * Rebuild against rebuild with default fPIC.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 14 Sep 2017 09:06:52 +0200

undertaker (1.6.1-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with gcc 7. (Closes: #853693)

 -- Adrian Bunk <bunk@debian.org>  Sun, 03 Sep 2017 14:54:27 +0300

undertaker (1.6.1-4) unstable; urgency=medium

  * Bug fix: "FTBFS in parallel builds", thanks to Lucas Nussbaum
    (Closes: #844980).
  * Bug fix: "add libfl-dev to Build-Depends", thanks to Helmut Grohne
    (Closes: #846452).

 -- Reinhard Tartler <siretart@debian.org>  Wed, 21 Dec 2016 21:03:52 +0000

undertaker (1.6.1-3) unstable; urgency=medium

  * Rebuild against aspectc++/libpuma 2.0
  * Rebuild against flex 2.6.1 (Closes: #833780), run flex at build-time.

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 05 Mar 2016 18:52:29 -0500

undertaker (1.6.1-2) unstable; urgency=medium

  * Regenerate with Flex 2.6.0 (Closes: #813264)
  * Fix FTBFS with newer Puma/AspectC++
  * Bump standards version (no changes needed)

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 27 Feb 2016 07:52:52 -0500

undertaker (1.6.1-1) unstable; urgency=medium

  * New upstream release
    - Incorporated patch for undertaker-checkpatch (Closes: #769137)
  * Add patch to fix FTBFS 'buildString' is not a member of 'Puma::StrCol'
    (Closes: #797896)
  * Relax CFLAGS (Don't add -Werror to everything)

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 19 Jan 2016 06:15:12 -0500

=== debian/control ===
Source: undertaker
Section: devel
Priority: optional
Maintainer: Christoph Egger <christoph@debian.org>
Uploaders: Reinhard Tartler <siretart@tauware.de>
Build-Depends:
 bison,
 check,
 debhelper (>= 9~),
 flex (>= 2.6.1),
 libboost-dev (>= 1.40),
 libboost-filesystem-dev (>= 1.40),
 libboost-regex-dev (>= 1.40),
 libboost-thread-dev (>= 1.40),
 libboost-wave-dev (>= 1.40),
 libfl-dev,
 libpstreams-dev,
 libpuma-dev (>= 1:2.1),
 picosat (>= 960),
 python-all (>= 2.6.6-3~)
Standards-Version: 3.9.7
Homepage: http://vamos.informatik.uni-erlangen.de/trac/undertaker
Vcs-Git: git://git.debian.org/git/collab-maint/undertaker.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/undertaker.git

Package: undertaker
Architecture: any
Depends: git, ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}
Description: variability-aware tool for static code analysis
 The "undertaker" is a tool suite for static source code analysis for
 checking C preprocessor directives. Also included are "golem", "vampyr"
 and "undertaker-tailor".
 .
 It can check their structure against different configuration models to
 find "dead" blocks that can never be selected and "undead" blocks that
 can never be deselected.
 .
 The included "golem" tool is able to infer variability constraints from
 Kbuild-like build systems, such as found in Linux, busybox and
 coreboot.  Its results greatly improves the model that undertaker uses
 for the analysis.
 .
 The tool "vampyr" is a conditional-compilation aware driver. It uses
 the "undertaker" tool to calculate a set of configurations and calls a
 backend-scanner on each of them. Supported scanners include: "gcc",
 "sparse", and "clang".
 .
 The tool "undertaker-tailor" calculates a kernel configuration based on
 a profile, which is traced with Linux ftrace mechanism. The resulting
 kernel exhibits a much smaller attack surface and results in a
 significant more secure kernel.

=== debian/rules ===
#!/usr/bin/make -f

UPSTREAM_VERSION=$(shell cat VERSION)

%:
	dh $@ --with python2

override_dh_auto_build:
	cd undertaker && make REGENERATE_PARSERS=1 regenerate_parsers -j1
	dh_auto_build -- -j1

override_dh_auto_install:
	dh_auto_install -- DESTDIR="$(CURDIR)/debian/tmp" PREFIX=/usr ETCDIR=/etc SETUP_PY_INSTALL_EXTRA_ARG="--root $(CURDIR)/debian/tmp --install-layout=deb"

override_dh_auto_test:
	#$(MAKE) check

override_dh_auto_clean:
	$(MAKE) clean
	rm -rf build

=== debian/watch ===
version=3

http://vamos.informatik.uni-erlangen.de/files/undertaker-(\d+[(.\d+)]+).tar.gz
